#ifndef _INIT_SQUARE_
#define _INIT_SQUARE_

#define _GNU_SOURCE //for ffsll
#include <stdlib.h>
#include <string.h>
#include "constants.h"
#include "types.h"
#include "test_check.h"

/**
 * AIM = find the initial square for a move like Bd5 ;
 * so easy for a human..
 * ..not so simple for a machine !
 */


//from wikipedia http://en.wikipedia.org/wiki/Binary_logarithm
//to find the last bit set
int flsll(Bitboard n);

// when sliders move, we have to check when it hits chessboard's boundaries
// this function return the right bitboard for a given initial square and direction
Bitboard getBoundaryBit(Bitboard square, int leftShift, int sizeShift);

// this function will take a destination square in parameter,
// and slide toward the indicated direction until it meets some corresponding slider
// (rook, bishop, queen) ; it can fail, and return #1111... (all 1's)
Bitboard tryOneWay(BoardState* bs, Bitboard destSquare, Bitboard piecesPos, int leftShift, int sizeShift);

// this function simply calls the one above, for two directions :
Bitboard tryTwoWays(BoardState* bs, Bitboard destSquare, Bitboard piecesPos,
                        int leftFirstShift, int sizeFirstShift, int leftNextShift, int sizeNextShift);


/****************************************************************/

// pawns == easy. no promotions because already done in the main parser.
Bitboard getInitSquare_pawns(BoardState* bs, Bitboard destSquare, int take, int file_is); // default 0 for last

/* other pieces : no flags, but harder to find the right init square..
 * types are here : 1=rooks, 2=knights, 3=bishops, 4=queens.
 * initial square of king is usually not so hard, so not included there.
 * rank_is and file_is are optional arguments giving hint for initial square, for moves like Nfg7
 */
Bitboard getInitSquare(BoardState* bs, Bitboard destSquare, char pieceType, int file_is, int rank_is); // default -1 for 2 lasts

#endif
