#include "safe_alloc.h"

void* safe_malloc (size_t size) {
    void* try = malloc (size);
    if (try == NULL) {
        printf("not_enough_memory\n");
        exit(1);
    }
    return try;
}

void* safe_calloc (size_t nelems, size_t szelem) {
    void* try = calloc (nelems, szelem);
    if (try == NULL) {
        printf("not_enough_memory\n");
        exit(1);
    }
    return try;
}

void* safe_realloc (void* ptr, size_t size) {
    void* try = realloc (ptr, size);
    if (try == NULL) {
        printf("not_enough_memory\n");
        exit(1);
    }
    return try;
}
