#ifndef _STACK_SM_
#define _STACK_SM_

#include <stdlib.h>
#include "types.h"
#include "safe_alloc.h"
#include "move.h"

// a function to [deep] copy a StateAndMove (BoardState + Move) object ;
// means allocate a full new structure. useful for SM' stacking in main parser
StateAndMove* safe_copySM(StateAndMove* sm);

//free all memory allocated for a SM' structure :
void free_contentsSM(StateAndMove* sm);


/*****************************
 * STACK operations
 */

//..on StateAndMove's :
void pushSM(StackSM** head, StateAndMove* sm);

StateAndMove* popSM(StackSM** head);

//..on int's (for parsing continuation moves) :
void pushInt(StackInt** head, int* cont);

int* popInt(StackInt** head);

#endif

