#ifndef _TYPES_
#define _TYPES_

#include <stdlib.h>
#include <stdint.h>

// just two aliases :
typedef uint64_t Bitboard;
typedef uint8_t Short;

// ..a stack of int's :
typedef struct stack_int {
    int* cont;
    struct stack_int* next;
} StackInt;

// structure to store the chessboard' state :
// Bitboard for full board, and for each type of piece / color
typedef struct board_state {
    Bitboard fullBoard;
    Bitboard* pawns; //[0] : black ; [1]: white
    Bitboard* rooks;
    Bitboard* knights;
    Bitboard* bishops;
    Bitboard* queens;
    Bitboard* kings; // exception : between 0 and 63 (up left to down right)
    int color; // who will move ? 1=white, 0=black
} BoardState;

// structure to store a move (+ flags)
typedef struct move {
    Bitboard initSquare;
    Bitboard destSquare;
    // flags :
    Short flags;
    Short vdepth;
} Move;

// structure StateAndMove == BoardState + Move :
typedef struct state_and_move {
    BoardState* bs;
    Move* mv;
} StateAndMove;

// ..a stack of StateAndMove's :
typedef struct stack_sm {
    StateAndMove* sm;
    struct stack_sm* next;
} StackSM;

#endif

