<?php

// informant style font ::
$nagArray_font = array (
	1 => '!',
	2 => '?',
	3 => '!!',
	4 => '??',
	5 => '!?',
	6 => '?!',
	7 => '&ocirc;', // forced move
	// 8 and 9 : singular, worst moves (how to print ?)
	// 10 to 12 : different types of equality
	10 => '=',
	11 => '=',
	12 => '=',
	13 => '&tilde;',
	14 => '&le;',
	15 => '&ge;',
	16 => '&plusmn;',
	17 => '&#181;',
	18 => '+-',
	19 => '-+',
	20 => '+--',
	21 => '--+',
	// 22 and 23: zugzwang nags
	22 => '&aacute;',
	23 => '&aacute;',
	// 24 to 29: several levels of space advantage
	24 => '&Uuml;',
	25 => '&Uuml;',
	26 => '&Uuml;',
	27 => '&Uuml;',
	28 => '&Uuml;',
	29 => '&Uuml;',
	// 30 to 35 : several levels of development advantage
	30 => '&acirc;',
	31 => '&acirc;',
	32 => '&acirc;',
	33 => '&acirc;',
	34 => '&acirc;',
	35 => '&acirc;',
	// 36 to 39: initiative (lasting or not)
	36 => '&Eacute;',
	37 => '&Eacute;',
	38 => '&Eacute;',
	39 => '&Eacute;',
	// 40 and 41: attack nags
	40 => '&Ccedil;',
	41 => '&Ccedil;',
	// 42 and 43: insufficient compensations for material loss
	// 44 and 45: adequate compensation for the material
	44 => '&infin;',
	45 => '&copy;',
	// 46 and 47 : " more than sufficient compensation",
	// --> should be nagged with slight advantage.. so ignore
	// 48 to 53 : graduate central advantages
	48 => '&icirc;',
	49 => '&icirc;',
	50 => '&icirc;',
	51 => '&icirc;',
	52 => '&icirc;',
	53 => '&icirc;',
	// 54 to 59 : kingside control advantages
	54 => '&ordf;',
	55 => '&ordf;',
	56 => '&ordf;',
	57 => '&ordf;',
	58 => '&ordf;',
	59 => '&ordf;',
	// 60 to 65 : queenside control advantages
	60 => '&acute;',
	61 => '&acute;',
	62 => '&acute;',
	63 => '&acute;',
	64 => '&acute;',
	65 => '&acute;',
	// 66 to 69 : about ranks protection...
	// 70 to 77 : about king protection...
	// 78 to 85 : pawn structure...
	// 86 to 101 : pieces placements...
	// 102 to 105 : pieces coordination...
	// 106 to 113: about how players performed in the opening..
	// 114 to 121 : ...in the middlegame..
	// 122 to 129 : ...in the ending..
	// 130 to 135 : counterplay
	130 => '&Ntilde;',
	131 => '&Ntilde;',
	132 => '&Ntilde;',
	133 => '&Ntilde;',
	134 => '&Ntilde;',
	135 => '&Ntilde;',
	// 136 to 139 : time pressure
	136 => '&igrave;',
	137 => '&igrave;',
	138 => '&igrave;',
	139 => '&igrave;',

	// I follow now (almost..) the palview manual :
	140 => ' &Ouml;', // with the idea of
	// NEXT = black triangle instead of reversed one in palview ; means "aiming at"
	141 => ' &aring;',
	142 => ' &pi;', // a better move is..
	143 => ' &atilde;', // weaker is.. (NIC)
	144 => ' &otilde;', // better is.. (NIC)
	145 => 'rr', //editorial comment
	146 => 'n', // novelty
	147 => 'r', // various moves
	148 => '&#711;', // endgame
	149 => '&euml;', // rank
	150 => '&iacute;', // diagonal
	// 151 and 152 : bishop pair advantage
	151 => '&ne;',
	152 => '&ne;',
	153 => '&AElig;', //opposite color bishops
	154 => '&Oslash;', // same color bishops
	// 155 and 156 : united pawns
	155 => '&Igrave;',
	156 => '&Igrave;',
	// 157 and 158 : separated pawns
	157 => '&Ocirc;',
	158 => '&Ocirc;',
	// 159 and 160 : doubled pawns
	159 => '&#xfb01;',
	160 => '&#xfb01;',
	// 161 and 162 : weak is.. (NIC)
	161 => ' <',
	162 => ' <',
	// 163 to 164: strong is.. (NIC)
	163 => ' >',
	164 => ' >',

	// completed with chessPad nags (http://en.wikipedia.org/wiki/Numeric_Annotation_Glyphs)
	//165 to 219 : Not defined
	//220 and 221 : their marks for diagrams (I will use different symbols)
	//222 to 237 : Not defined
	238 => '&Uuml;', //Space advantage 				
	239 => '&ntilde;', //File (nag for rank is $149)
	240 => '&iacute;', //Diagonal
	//241 : center (control ? occupation ?..)
	242 => '&ordf;', //King-side control
	243 => '&acute;', //Queen-side control
	244 => 'x', //Weak point
	245 => '&#711;', //Ending
	246 => '&ne;', //Bishop pair
	247 => '&AElig;', //Opposite color bishops
	248 => '&Oslash;', //Same color bishops
	249 => '&Igrave;', //Connected pawns
	250 => '&Ocirc;', //Isolated pawns
	251 => '&#xfb01;', //Doubled pawns
	252 => '&#x2db;', //Passed pawn
	253 => '&#xfb02;' //Pawns majority
	//254 : With
	//255 : Without
);

// alternative textal indications :
$nagArray_text = array (
	1 => "!",
	2 => "?",
	3 => "!!",
	4 => "??",
	5 => "!?",
	6 => "?!",
	7 => " (forced)",
	8 => " (singular move)",
	9 => " (the worst move)",
	10 => " = (drawish)",
	11 => " = (quiet)",
	12 => " = (dynamic)",
	13 => " unclear position",
	14 => " +/=",
	15 => " =/+",
	16 => " +-",
	17 => " -+",
	18 => " +/-",
	19 => " -/+",
	20 => " ++/-",
	21 => " --/+",
	22 => " White is in zugzwang",
	23 => " Black is in zugzwang",
	24 => " White has a slight space advantage",
	25 => " Black has a slight space advantage",
	26 => " White has a moderate space advantage",
	27 => " Black has a moderate space advantage",
	28 => " White has a decisive space advantage",
	29 => " Black has a decisive space advantage",
	30 => " White has a slight development advantage",
	31 => " Black has a slight development advantage",
	32 => " White has a moderate development advantage",
	33 => " Black has a moderate development advantage",
	34 => " White has a decisive development advantage",
	35 => " Black has a decisive development advantage",
	36 => " White has the initiative",
	37 => " Black has the initiative",
	38 => " White has a lasting initiative",
	39 => " Black has a lasting initiative",
	40 => " White has the attack",
	41 => " Black has the attack",
	42 => " White has insufficient compensation for material deficit",
	43 => " Black has insufficient compensation for material deficit",
	44 => " White has sufficient compensation for material deficit",
	45 => " Black has sufficient compensation for material deficit",
	46 => " White has more than adequate compensation for material deficit",
	47 => " Black has more than adequate compensation for material deficit",
	48 => " White has a slight center control advantage",
	49 => " Black has a slight center control advantage",
	50 => " White has a moderate center control advantage",
	51 => " Black has a moderate center control advantage",
	52 => " White has a decisive center control advantage",
	53 => " Black has a decisive center control advantage",
	54 => " White has a slight kingside control advantage",
	55 => " Black has a slight kingside control advantage",
	56 => " White has a moderate kingside control advantage",
	57 => " Black has a moderate kingside control advantage",
	58 => " White has a decisive kingside control advantage",
	59 => " Black has a decisive kingside control advantage",
	60 => " White has a slight queenside control advantage",
	61 => " Black has a slight queenside control advantage",
	62 => " White has a moderate queenside control advantage",
	63 => " Black has a moderate queenside control advantage",
	64 => " White has a decisive queenside control advantage",
	65 => " Black has a decisive queenside control advantage",
	66 => " White has a vulnerable first rank",
	67 => " Black has a vulnerable first rank",
	68 => " White has a well protected first rank",
	69 => " Black has a well protected first rank",
	70 => " White has a poorly protected king",
	71 => " Black has a poorly protected king",
	72 => " White has a well protected king",
	73 => " Black has a well protected king",
	74 => " White has a poorly placed king",
	75 => " Black has a poorly placed king",
	76 => " White has a well placed king",
	77 => " Black has a well placed king",
	78 => " White has a very weak pawn structure",
	79 => " Black has a very weak pawn structure",
	80 => " White has a moderately weak pawn structure",
	81 => " Black has a moderately weak pawn structure",
	82 => " White has a moderately strong pawn structure",
	83 => " Black has a moderately strong pawn structure",
	84 => " White has a very strong pawn structure",
	85 => " Black has a very strong pawn structure",
	86 => " White has poor knight placement",
	87 => " Black has poor knight placement",
	88 => " White has good knight placement",
	89 => " Black has good knight placement",
	90 => " White has poor bishop placement",
	91 => " Black has poor bishop placement",
	92 => " White has good bishop placement",
	93 => " Black has good bishop placement",
	84 => " White has poor rook placement",
	85 => " Black has poor rook placement",
	86 => " White has good rook placement",
	87 => " Black has good rook placement",
	98 => " White has poor queen placement",
	99 => " Black has poor queen placement",
	100 => " White has good queen placement",
	101 => " Black has good queen placement",
	102 => " White has poor piece coordination",
	103 => " Black has poor piece coordination",
	104 => " White has good piece coordination",
	105 => " Black has good piece coordination",
	106 => " White has played the opening very poorly",
	107 => " Black has played the opening very poorly",
	108 => " White has played the opening poorly",
	109 => " Black has played the opening poorly",
	110 => " White has played the opening well",
	111 => " Black has played the opening well",
	112 => " White has played the opening very well",
	113 => " Black has played the opening very well",
	114 => " White has played the middlegame very poorly",
	115 => " Black has played the middlegame very poorly",
	116 => " White has played the middlegame poorly",
	117 => " Black has played the middlegame poorly",
	118 => " White has played the middlegame well",
	119 => " Black has played the middlegame well",
	120 => " White has played the middlegame very well",
	121 => " Black has played the middlegame very well",
	122 => " White has played the ending very poorly",
	123 => " Black has played the ending very poorly",
	124 => " White has played the ending poorly",
	125 => " Black has played the ending poorly",
	126 => " White has played the ending well",
	127 => " Black has played the ending well",
	128 => " White has played the ending very well",
	129 => " Black has played the ending very well",
	130 => " White has slight counterplay",
	131 => " Black has slight counterplay",
	132 => " White has moderate counterplay",
	133 => " Black has moderate counterplay",
	134 => " White has decisive counterplay",
	135 => " Black has decisive counterplay",
	136 => " White has moderate time control pressure",
	137 => " Black has moderate time control pressure",
	138 => " White has severe time control pressure",
	139 => " Black has severe time control pressure",

	140 => " , with the idea of",
	141 => " , aiming against",
	142 => " ; a better move is",
	143 => " ; weaker is",
	144 => " ; better is",
	145 => "RR",
	146 => "N",
	147 => "R",
	148 => " (endgame reached)",
	149 => " (controlling rank)",
	150 => " (controlling diagonal)",
	151 => " bishop pair advantage",
	152 => " bishop pair advantage",
	153 => " opposite color bishops",
	154 => " same color bishops",
	155 => " united pawns",
	156 => " united pawns",
	157 => " separated pawns",
	158 => " separated pawns",
	159 => " isolated pawns",
	160 => " isolated pawns",
	161 => " (weak move)",
	162 => " (weak move)",
	163 => " (strong move)",
	164 => " (strong move)",

	238 => " with a space advantage", 				
	239 => " (controlling file)",
	240 => " (controlling diagonal)",
	//241 : center (control ? occupation ?..)
	242 => " with kingside control advantage",
	243 => " with queenside control advantage",
	244 => " (weak point)",
	245 => " (endgame reached)",
	246 => " bishop pair advantage",
	247 => " opposite color bishops",
	248 => " same color bishops",
	249 => " connected pawns",
	250 => " isolated pawns",
	251 => " doubled pawns",
	252 => " passed pawn",
	253 => " pawns majority"
	//254 : With
	//255 : Without
);

// get NAGS from numbers :
function replaceNag($string, $nagsfont) {

	global $nagArray_font, $nagArray_text;
	$nagNum = (int) $string;

	if ($nagsfont) {
		// informant style font ::
		return '<span class="fina">'.$nagArray_font[$nagNum].'</span>';
	}

	// alternative textal indications :
	return $nagArray_text[$nagNum];

}

?>

