<?php

// here we create images files which could be missing, depending on requests

function getElemsPaths($squareSize, $pieceStyle, $simpctrp) {

	// create pieces files, empty square and control panel ALIASES :

	$resizedPiecePath = './printings/pieces/'.$pieceStyle.'/size'.$squareSize.'/';
	$wcpan = min( max(100, 8 * $squareSize), 360);
	$divBy = ($simpctrp ? 6 : 9);
	$hcpan = min( ($simpctrp ? 35 : 40) , round( $wcpan / $divBy ) - 3 ); // 3 is somewhat arbitrary...
	$wcpan = $wcpan - $wcpan % $divBy; // MUST be multiple of $divBy -- because $divBy squares in ctr panel
	$charSimp = ($simpctrp ? 's' : '');

	$ep = array(
		"bp" => $resizedPiecePath.'bp.png',
		"br" => $resizedPiecePath.'br.png',
		"bn" => $resizedPiecePath.'bn.png',
		"bb" => $resizedPiecePath.'bb.png',
		"bq" => $resizedPiecePath.'bq.png',
		"bk" => $resizedPiecePath.'bk.png',
		"wp" => $resizedPiecePath.'wp.png',
		"wr" => $resizedPiecePath.'wr.png',
		"wn" => $resizedPiecePath.'wn.png',
		"wb" => $resizedPiecePath.'wb.png',
		"wq" => $resizedPiecePath.'wq.png',
		"wk" => $resizedPiecePath.'wk.png',
		"empty" => './printings/emptySquares/i'.$squareSize.'.png',
		"ctrpan" => './printings/controlPanels/ctrp'.$charSimp.$squareSize.'.png',
		"ctrpanv" => ($simpctrp ?
			'./printings/controlPanels/ctrps'.$squareSize.'.png' :
			'./printings/controlPanels/ctrpv'.$squareSize.'.png' // same but with stepvar active (if visible)
			),
		"wcpan" => $wcpan,
		"hcpan" => $hcpan
	);
	return $ep;
}


// this function could create directories and files ; should be allowed on the server..
function createElemsImages($ep, $squareSize, $pieceStyle, $simpctrp) {

	$basePiecePath = '../../printings/pieces/'.$pieceStyle.'/';
	$resizedPiecePath = $basePiecePath.'size'.$squareSize.'/';

	// check if directory for this set of pieces (size, style) exists :
	if ( ! file_exists($resizedPiecePath) ) {
		// if not, we create everything [use GD library]
		mkdir($resizedPiecePath, 0755);

		$resizedPiece =  imageCreateTrueColor($squareSize,$squareSize);
		imageAlphaBlending($resizedPiece,FALSE);
		imageSaveAlpha($resizedPiece,TRUE);

		$black_pawn = imageCreateFromPNG($basePiecePath.'black_pawn.png');
		$initWidth = imageSx($black_pawn);
		imageCopyResampled($resizedPiece,$black_pawn,0,0,0,0,$squareSize,$squareSize,$initWidth,$initWidth);
		imageDestroy($black_pawn);
		imagePNG($resizedPiece, '../.'.$ep["bp"], 9);

		$black_rook = imageCreateFromPNG($basePiecePath.'black_rook.png');
		imageCopyResampled($resizedPiece,$black_rook,0,0,0,0,$squareSize,$squareSize,$initWidth,$initWidth);
		imageDestroy($black_rook);
		imagePNG($resizedPiece, '../.'.$ep["br"], 9);

		$black_knight = imageCreateFromPNG($basePiecePath.'black_knight.png');
		imageCopyResampled($resizedPiece,$black_knight,0,0,0,0,$squareSize,$squareSize,$initWidth,$initWidth);
		imageDestroy($black_knight);
		imagePNG($resizedPiece, '../.'.$ep["bn"], 9);

		$black_bishop = imageCreateFromPNG($basePiecePath.'black_bishop.png');
		imageCopyResampled($resizedPiece,$black_bishop,0,0,0,0,$squareSize,$squareSize,$initWidth,$initWidth);
		imageDestroy($black_bishop);
		imagePNG($resizedPiece, '../.'.$ep["bb"], 9);

		$black_queen = imageCreateFromPNG($basePiecePath.'black_queen.png');
		imageCopyResampled($resizedPiece,$black_queen,0,0,0,0,$squareSize,$squareSize,$initWidth,$initWidth);
		imageDestroy($black_queen);
		imagePNG($resizedPiece, '../.'.$ep["bq"], 9);

		$black_king = imageCreateFromPNG($basePiecePath.'black_king.png');
		imageCopyResampled($resizedPiece,$black_king,0,0,0,0,$squareSize,$squareSize,$initWidth,$initWidth);
		imageDestroy($black_king);
		imagePNG($resizedPiece, '../.'.$ep["bk"], 9);

		//..and whites :
		$white_pawn = imageCreateFromPNG($basePiecePath.'white_pawn.png');
		imageCopyResampled($resizedPiece,$white_pawn,0,0,0,0,$squareSize,$squareSize,$initWidth,$initWidth);
		imageDestroy($white_pawn);
		imagePNG($resizedPiece, '../.'.$ep["wp"], 9);

		$white_rook = imageCreateFromPNG($basePiecePath.'white_rook.png');
		imageCopyResampled($resizedPiece,$white_rook,0,0,0,0,$squareSize,$squareSize,$initWidth,$initWidth);
		imageDestroy($white_rook);
		imagePNG($resizedPiece, '../.'.$ep["wr"], 9);

		$white_knight = imageCreateFromPNG($basePiecePath.'white_knight.png');
		imageCopyResampled($resizedPiece,$white_knight,0,0,0,0,$squareSize,$squareSize,$initWidth,$initWidth);
		imageDestroy($white_knight);
		imagePNG($resizedPiece, '../.'.$ep["wn"], 9);

		$white_bishop = imageCreateFromPNG($basePiecePath.'white_bishop.png');
		imageCopyResampled($resizedPiece,$white_bishop,0,0,0,0,$squareSize,$squareSize,$initWidth,$initWidth);
		imageDestroy($white_bishop);
		imagePNG($resizedPiece, '../.'.$ep["wb"], 9);

		$white_queen = imageCreateFromPNG($basePiecePath.'white_queen.png');
		imageCopyResampled($resizedPiece,$white_queen,0,0,0,0,$squareSize,$squareSize,$initWidth,$initWidth);
		imageDestroy($white_queen);
		imagePNG($resizedPiece, '../.'.$ep["wq"], 9);

		$white_king = imageCreateFromPNG($basePiecePath.'white_king.png');
		imageCopyResampled($resizedPiece,$white_king,0,0,0,0,$squareSize,$squareSize,$initWidth,$initWidth);
		imageDestroy($white_king);
		imagePNG($resizedPiece, '../.'.$ep["wk"], 9);
		imageDestroy($resizedPiece);
	}

	// if not exists, we add the right sized empty square ; useful to make pieces disappear !
	if ( ! file_exists($ep["empty"]) ) {
		$empty_square =  imageCreateTrueColor($squareSize,$squareSize);
		$black = imageColorAllocate($empty_square,0,0,0);
		imageColorTransparent($empty_square, $black);		
		imagePNG($empty_square, '../.'.$ep["empty"], 9);
		imageDestroy($empty_square);
	}

	// and create the control panel image if needed :
	if ( ! file_exists($ep["ctrpan"]) ) {
		$resizedPanel = imageCreate($ep["wcpan"], $ep["hcpan"]);
		$charSimp = ($simpctrp ? 's' : '');
		$control_panel = imageCreateFromPNG('../../printings/controlPanels/ctrp'.$charSimp.'.png');
		$initWidth = imageSx($control_panel);
		$initHeight = imageSy($control_panel);
		imageCopyResized($resizedPanel,$control_panel,0,0,0,0,$ep["wcpan"],$ep["hcpan"],$initWidth,$initHeight);
		imageDestroy($control_panel);
		imagePNG($resizedPanel, '../.'.$ep["ctrpan"], 9);
		imageDestroy($resizedPanel);

		// if needed, also create panel with 'v' at the end, ctrpv|size.png, for full panel with stepvar active :
		if ( ! $simpctrp ) {
			$resizedPanel = imageCreate($ep["wcpan"], $ep["hcpan"]);
			$control_panel = imageCreateFromPNG('../../printings/controlPanels/ctrpv.png');
			// ok, same size, no need to recompute width and height :
			imageCopyResized($resizedPanel,$control_panel,0,0,0,0,$ep["wcpan"],$ep["hcpan"],$initWidth,$initHeight);
			imageDestroy($control_panel);
			imagePNG($resizedPanel, '../.'.$ep["ctrpanv"], 9);
			imageDestroy($resizedPanel);
		}
	}
}

?>

