<?php

// print crosstable (if asked) :
function printCT($headers) {
	// 1) array associating name1-name2 --> score(s)
	$names = array();
	for ($i=0; $i < count($headers); $i++) {
		$names[ $headers[$i]["White"] ] = 1; // just says "this player is in the tournament"
		$names[ $headers[$i]["Black"] ] = 1;
	}
	$allNames = array_keys($names);
	$scores = array(
		array_fill_keys( $allNames, array_fill_keys( $allNames, 0 ) ),
		array_fill_keys( $allNames, array_fill_keys( $allNames, 0 ) ) );
	for ($i=0; $i < count($headers); $i++) {
		if ($headers[$i]["Result"][0]=='1' && $headers[$i]["Result"][1]=='-')
			$scores [1] [ $headers[$i]["White"] ] [ $headers[$i]["Black"] ] ++; // white wins
		else if ($headers[$i]["Result"][0]=='0')
			$scores [0] [ $headers[$i]["Black"] ] [ $headers[$i]["White"] ] ++; // black wins
		else { //draw
			$scores [1] [ $headers[$i]["White"] ] [ $headers[$i]["Black"] ] += 0.5;
			$scores [0] [ $headers[$i]["Black"] ] [ $headers[$i]["White"] ] += 0.5;
		}
	}

	// 2) fill the array "name -> rank", bottom->top, then sort it
	foreach ($names as $key => $value) {
		$names[$key] = 0;
		$fkey = $key;
		foreach ($names as $key => $value) {
			$names[$fkey] += ($scores[1][$fkey][$key] + $scores[0][$fkey][$key]);
		}
	}
	asort($names, SORT_NUMERIC);
	$names = array_reverse($names, TRUE);

	// 3) fill the table with gathered informations
	echo '<table id="crosst">
<tr> <th></th>';
	foreach ($names as $key => $value) {
		echo '<th>'.$key.'</th> ';
	}
	echo '<th>Points</th> </tr>
';
	foreach ($names as $key => $value) {
		echo '<tr> <th>'.$key.'</th>';
		$fkey = $key;
		foreach ($names as $key => $value) {
			echo '<td class="score">';
			if ($fkey == $key)
				echo '*';
			else {
				echo ($scores[1][$fkey][$key]+0).' - '.($scores[0][$fkey][$key]+0);
			}
			echo '</td>';
		}
		echo '<td class="sscore">'.$names[$fkey].'</td> </tr>
';
	}
	echo '</table>
';
}

// print inital chessboard :
function printInitialBoard($ep, $gameNum) {

	echo '<!-- the chessboard is printed as an array of 64 square images -->
<table class="chessboard">
<tr>
';

	// black side : first piece printed must have an id, which will be used by javascript
	echo '<td class="l"><img name="brd'.$gameNum.'" src="'.$ep["br"].'"></td>
<td class="d"><img src="'.$ep["bn"].'"></td>
<td class="l"><img src="'.$ep["bb"].'"></td>
<td class="d"><img src="'.$ep["bq"].'"></td>
<td class="l"><img src="'.$ep["bk"].'"></td>
<td class="d"><img src="'.$ep["bb"].'"></td>
<td class="l"><img src="'.$ep["bn"].'"></td>
<td class="d"><img src="'.$ep["br"].'"></td>
</tr>
<tr>
';
	for ($i = 0; $i < 8; $i++) {
		echo '<td class="'; echo ($i%2 ? 'l' : 'd'); echo '"><img src="'.$ep["bp"].'"></td>
';
	}

	// 32 empty squares :
	echo '</tr>
<tr>
';
	for ($i = 0; $i < 8; $i++) {
		echo '<td class="'; echo ($i%2 ? 'd' : 'l'); echo '"><img src="'.$ep["empty"].'"></td>
';
	}
	echo '</tr>
<tr>
';
	for ($i = 0; $i < 8; $i++) {
		echo '<td class="'; echo ($i%2 ? 'l' : 'd'); echo '"><img src="'.$ep["empty"].'"></td>
';
	}
	echo '</tr>
<tr>
';
	for ($i = 0; $i < 8; $i++) {
		echo '<td class="'; echo ($i%2 ? 'd' : 'l'); echo '"><img src="'.$ep["empty"].'"></td>
';
	}
	echo '</tr>
<tr>
';
	for ($i = 0; $i < 8; $i++) {
		echo '<td class="'; echo ($i%2 ? 'l' : 'd'); echo '"><img src="'.$ep["empty"].'"></td>
';
	}

	// white side :
	echo '</tr>
<tr>
';
	for ($i = 0; $i < 8; $i++) {
		echo '<td class="'; echo ($i%2 ? 'd' : 'l'); echo '"><img src="'.$ep["wp"].'"></td>
';
	}
	echo '</tr>
<tr>
<td class="d"><img src="'.$ep["wr"].'"></td>
<td class="l"><img src="'.$ep["wn"].'"></td>
<td class="d"><img src="'.$ep["wb"].'"></td>
<td class="l"><img src="'.$ep["wq"].'"></td>
<td class="d"><img src="'.$ep["wk"].'"></td>
<td class="l"><img src="'.$ep["wb"].'"></td>
<td class="d"><img src="'.$ep["wn"].'"></td>
<td class="l"><img src="'.$ep["wr"].'"></td>
</tr>
</table>
';

}

// print control button below board :
function printControlPanel($ep, $gameNum, $simpctrp) {

	// free space to fill the last move played in javascript
	echo '
<p id="mp'.$gameNum.'" class="lastmove">initial position</p>

<!-- image of '; echo ($simpctrp ? 'simplified' : 'full'); echo ' control panel -->
<img id="cp'.$gameNum.'" class="ctrpan" src="'.$ep["ctrpan"].'" usemap="#ctr'.$gameNum.'">

';

	$wcpan = $ep["wcpan"];
	$hstep = round ($wcpan / ($simpctrp ? 6 : 9) );
	$hcpan = $ep["hcpan"];

	// map of the javascript functions to call in the image :
echo '<!-- and corresponding map to enable javascript moving, as in palview -->
<map name="ctr'.$gameNum.'">';

	// simplified control panel (no play/back 5, no step into variations buttons)
	if ($simpctrp) {
		echo '
	<area coords="1,1,'; echo $hstep; echo ','; echo $hcpan;
		echo '" alt="go to beginning" onClick="GoBegin_('; echo $gameNum; echo ')">
	<area coords="'; echo ($hstep + 1); echo ',1,'; echo (2*$hstep); echo ','; echo $hcpan;
		echo '" alt="back one move" onClick="Back_('; echo $gameNum; echo ');">
	<area coords="'; echo (2*$hstep + 1); echo ',1,'; echo (3*$hstep); echo ','; echo $hcpan;
		echo '" alt="play one move" onClick="Play_('; echo $gameNum; echo ');">
	<area coords="'; echo (3*$hstep + 1); echo ',1,'; echo (4*$hstep); echo ','; echo $hcpan;
		echo '" alt="go to end" onClick="GoToEnd_('; echo $gameNum; echo ');">
	<area coords="'; echo (4*$hstep + 1); echo ',1,'; echo (5*$hstep); echo ','; echo $hcpan;
		echo '" alt="flip board" onClick="FlipBoard_('; echo $gameNum; echo ');">
	<area coords="'; echo (5*$hstep + 1); echo ',1,'; echo (6*$hstep); echo ','; echo $hcpan;
		echo '" alt="autoplay" onClick="Autoplay_('; echo $gameNum; echo ');">';
	}

	// "full featured" control panel, as in palview :
	else {
		echo '
	<area coords="1,1,'; echo $hstep; echo ','; echo $hcpan;
		echo '" alt="go to beginning" onClick="GoBegin_('; echo $gameNum; echo ')">
	<area coords="'; echo ($hstep + 1); echo ',1,'; echo (2*$hstep); echo ','; echo $hcpan;
		echo '" alt="back five moves" onClick="BackFive_('; echo $gameNum; echo ');">
	<area coords="'; echo (2*$hstep + 1); echo ',1,'; echo (3*$hstep); echo ','; echo $hcpan;
		echo '" alt="back one move" onClick="Back_('; echo $gameNum; echo ');">
	<area coords="'; echo (3*$hstep + 1); echo ',1,'; echo (4*$hstep); echo ','; echo $hcpan;
		echo '" alt="play one move" onClick="Play_('; echo $gameNum; echo ');">
	<area coords="'; echo (4*$hstep + 1); echo ',1,'; echo (5*$hstep); echo ','; echo $hcpan;
		echo '" alt="play five moves" onClick="PlayFive_('; echo $gameNum; echo ');">
	<area coords="'; echo (5*$hstep + 1); echo ',1,'; echo (6*$hstep); echo ','; echo $hcpan;
		echo '" alt="go to end" onClick="GoToEnd_('; echo $gameNum; echo ');">
	<area coords="'; echo (6*$hstep + 1); echo ',1,'; echo (7*$hstep); echo ','; echo $hcpan;
		echo '" alt="flip board" onClick="FlipBoard_('; echo $gameNum; echo ');">
	<area coords="'; echo (7*$hstep + 1); echo ',1,'; echo (8*$hstep); echo ','; echo $hcpan;
		echo '" alt="autoplay" onClick="Autoplay_('; echo $gameNum; echo ');">
	<area coords="'; echo (8*$hstep + 1); echo ',1,'; echo (9*$hstep); echo ','; echo $hcpan;
		echo '" alt="step into variation" onClick="StepVar_('; echo $gameNum; echo ');">';
	}
	echo '
</map>';

}

// decorate ELO if available :
function getEloStr($string) {
	if ($string == "") return "";
	return '('.$string.')';
}


// print game informations above moves, in a new container
function printHeader($header) {

	if (!array_key_exists("WhiteElo", $header))
		$header["WhiteElo"] = "";
	if (!array_key_exists("BlackElo", $header))
		$header["BlackElo"] = "";

	echo '<br>

<!-- here is the game header, containing tags of the PGN file -->
<table class="gameinfos">
<tr><td class="plys">
'.$header["White"].' <span class="elo">'.getEloStr($header["WhiteElo"]).'</span><br>
'.$header["Black"].' <span class="elo">'.getEloStr($header["BlackElo"]).'</span>
</td>
<td class="eco">
'.$header["ECO"].'
</td></tr>
<tr><td class="date">
'.$header["Date"].'
</td></tr>
<tr><td>
<span class="roev"> Round '.$header["Round"].' of '.$header["Event"].' </span> - <span class="site">'.$header["Site"].'</span>';
if (array_key_exists("Annotator", $header) && $header["Annotator"] != "") {
	echo '<br>
<span class="anno"> Annotator : '.$header["Annotator"].'</span>';
}
echo '
</table>
';

}

// file containing (almost) all nags glyphs to be printed, and textual alternatives :
include_once ("nags_arrays.php");

// print one move from its string :
function printMove($moveStr, $gameNum, $moveNum, $figurs, $nagsfont, $movelks) {

	if ($movelks) echo '<span id="m'.$gameNum.'_'.$moveNum.'" onClick="GotoMove_('.$gameNum.','.$moveNum.');">';

    // [optional] FIRST TOKEN : dots or number
    $i = 0;
    while ($moveStr[$i] == '.' || ($moveStr[$i] >= '0' && $moveStr[$i] <= '9')) $i++;
	echo substr($moveStr, 0, $i);
	echo ' ';

    // SECOND TOKEN : the move itself
	if ($figurs && strpos("_RNBQK",$moveStr[$i])) {
		// print character :
		echo '<span class="fina">'.$moveStr[$i].'</span>';
		// print following next..
		$i++;
	}

	// watch out nag !
	$startInd = $i;
	while ($i < strlen($moveStr) && $moveStr[$i] != '$') $i++;
	if ($i < strlen($moveStr)) {
		echo substr($moveStr, $startInd, $i - $startInd);
		// [optional] THIRD TOKEN : the nag $xx
		echo replaceNag( substr($moveStr, $i+1, strlen($moveStr) - $i - 1), $nagsfont );
	}
	else {
		// no nag :
		echo substr($moveStr, $startInd, $i - $startInd);
	}

	if ($movelks) echo '</span> ';
}

// print the entire game :
function printGame($gameNum, $moves, $figurs, $nagsfont, $movelks, $comments, $varout, $result) {

	echo '
<!-- and finally, the moves list with many "id" and javascript calls for further retrieval -->
<p>
<span class="moves"> '; //default

	$justOutMain = FALSE; //if we just went out a variant from main line, this is at TRUE (for lines jumps)
	$justOutVar = FALSE; //if we just went out a variant from a variant, this is at TRUE (for lines jumps)
	$depthVar = 0;
	$curTokNum = 0;
	$curMoveNum = 0;
	$curTok = strtok($moves, ' ');
	$noUpTok = FALSE;

    while ($curTok != FALSE) {

        // first digit (or dot or letter a-h, RNBQK, O if black) of a game move :
        if (($curTok[0] >= '1' && $curTok[0] <= '9') || ($curTok[0] >= 'a' && $curTok[0] <= 'h')
                || strpos("_RNBQK",$curTok[0]) || $curTok[0] == 'O' || $curTok[0] == '.') {
			if (array_key_exists($curTokNum, $comments) && $comments[$curTokNum] != "") echo '<span class="comms">'.$comments[$curTokNum].'</span> ';
			printMove( $curTok, $gameNum, $curMoveNum++, $figurs, $nagsfont, $movelks);
			if ($curMoveNum % 2 == 0) echo '
';
			$justOutMain = FALSE;
			$justOutVar = FALSE;
        }

		// an isolated nag, like "with the idea of.." :
		else if ($curTok[0] == '$') {
			if (array_key_exists($curTokNum, $comments) && $comments[$curTokNum] != "") echo '<span class="comms">'.$comments[$curTokNum].'</span> ';
			echo replaceNag( substr($curTok, 1, strlen($curTok) - 1), $nagsfont);
			echo ' ';
			$justOutMain = FALSE;
			$justOutVar = FALSE;
		}

        else if ($curTok[0] == '(') {
            // beginning of a variation
			if (array_key_exists($curTokNum, $comments) && $comments[$curTokNum] != "") echo '<span class="comms">'.$comments[$curTokNum].'</span> ';
			if ($depthVar == 0) {
				// right after main line :
				echo '</span> ';
				if ($varout >= 1 && ! $justOutMain) echo '<br> ';
				echo '<span class="vars"> ';
            }
			else {
				if ($varout == 2) {
					if (! $justOutVar) echo '<br> ';
					for ($i=0; $i < $depthVar; $i++) echo '&nbsp;&nbsp;&nbsp;&nbsp; ';
				}
				echo '( ';
			}
			$depthVar++;
			$justOutMain = FALSE;
			$justOutVar = FALSE;
		}

        else if ($curTok[0] == ')') {
            // end of a variation
			$depthVar--;
			if (array_key_exists($curTokNum, $comments) && $comments[$curTokNum] != "") echo '<span class="comms">'.$comments[$curTokNum].'</span> ';
			if ($depthVar == 0) {
				// go back to main line :
				echo '</span><span class="moves"> ';
				$justOutMain = TRUE;
            }
			else {
				echo ') ';
				if ($varout == 2) {
					// we need to know what's next !
					$curTok = strtok(' ');
					$noUpTok = TRUE;
					if ($curTok[0] != ')') {
						echo '<br> ';
						for ($i=0; $i < $depthVar-1; $i++) echo '&nbsp;&nbsp;&nbsp;&nbsp; ';
					}
				}
				$justOutVar = TRUE;
			}
		}
		$curTokNum++;
		if (! $noUpTok) $curTok = strtok(' ');
		$noUpTok = FALSE;
    }

	// print last comment if any :
	if (array_key_exists($curTokNum, $comments) && $comments[$curTokNum] != "") echo '<span class="comms">'.$comments[$curTokNum].'</span> ';

	// finally print game result !
	echo $result;

	echo '</span>
</p>';

}

?>

